<?php ini_set('display_errors', 1);
error_reporting(E_ALL);


include_once DIR_SYSTEM . "/library/egoi/egoi_api.php";

/**
 * Class ControllerExtensionModuleSmartMarketing
 * @author E-goi
 */
class ControllerExtensionModuleSmartMarketing extends Controller
{

	/**
	 * EGOI TEMPLATE DELIMITER
	 */
	const EGOI_TEMPLATE_DELIMITER = '%';

    /**
     * Used to set the errors, if any.
     *
     * @var array
     */
    private $error = array();

    /**
     * @var int
     */
    private $version = 133;

    /**
     * @var SoapClient
     */
    private $api;

	/**
	 * @var mixed
	 */
    private $set_modification;

	/**
	 * @var array
	 */
    private $reminder_interval = array('1', '8', '12', '24', '36', '48', '72');

	/**
	 * @var array
	 */
    private $available_notifications = array();

	/**
	 * @var string
	 */
    private $plugin_url = 'https://goidini.e-goi.com/resources/plugins/opencart/smart-marketing-opencart3.latest.ocmod.zip';
	/**
	 * @var array
	 */
	private $helpoc = array(
		array(
			'title'       => 'text_section_smsnotification_help_title_1',
			'description' => 'text_section_smsnotification_help_description_1'
		),
		array(
			'title'       => 'text_section_smsnotification_help_title_2',
			'description' => 'text_section_smsnotification_help_description_2'
		),
		array(
			'title'       => 'text_section_smsnotification_help_title_3',
			'description' => 'text_section_smsnotification_help_description_3'
		),
		array(
			'title'       => 'text_section_smsnotification_help_title_4',
			'description' => 'text_section_smsnotification_help_description_4'
		),
		array(
			'title'       => 'text_section_smsnotification_help_title_5',
			'description' => 'text_section_smsnotification_help_description_5'
		),
		array(
			'title'       => 'text_section_smsnotification_help_title_6',
			'description' => 'text_section_smsnotification_help_description_6'
		)
	);


	/**
	 * @var array
	 */
	private $egoiTemplating = array(
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_order_id',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'order_id' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_order_status',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'order_status' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_total',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'total' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_currency',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'currency' . self::EGOI_TEMPLATE_DELIMITER
		),
//		array(
//			'label' => 'text_section_smsnotification_sms_notifications_code_payment_method',
//			'code' => self::EGOI_TEMPLATE_DELIMITER.'payment_method'.self::EGOI_TEMPLATE_DELIMITER
//		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_ref',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'ref' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_ent',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'ent' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_shop_name',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'shop_name' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_billing_name',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'billing_name' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_tracking_name',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'tracking_name' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_tracking_code',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'tracking_code' . self::EGOI_TEMPLATE_DELIMITER
		),
		array(
			'label' => 'text_section_smsnotification_sms_notifications_code_tracking_url',
			'code'  => self::EGOI_TEMPLATE_DELIMITER . 'tracking_url' . self::EGOI_TEMPLATE_DELIMITER
		)
	);

	/**
	 * @var array
	 */
	private $defaultMessages = array(
		'default'   => array(
			'en-gb'   => 'Hello, %billing_name% Your order at %shop_name% is %order_status%. Thank you',
			'en-us'   => 'Hello, %billing_name% Your order at %shop_name% is %order_status%. Thank you',
			'pt-pt'   => 'Olá, %billing_name% a sua encomenda em %shop_name% encontra-se %order_status%. Obrigado',
			'pt-br'   => 'Olá, %billing_name% a sua encomenda em %shop_name% encontra-se %order_status%. Obrigado',
			'es-es'   => 'Hola, %billing_name% su pedido en %shop_name% se encuentra %order_status%. Gracias',
			'default' => 'Hello, %billing_name% Your order at %shop_name% is %order_status%. Thank you'
		),
		'reminders' => array(
			'en-gb'   => 'Hello, %billing_name% Your order at %shop_name% is %order_status%. Thank you',
			'en-us'   => 'Hello, %billing_name% Your order at %shop_name% is %order_status%. Thank you',
			'pt-pt'   => 'Olá, %billing_name% a sua encomenda em %shop_name% encontra-se %order_status%. Obrigado',
			'pt-br'   => 'Olá, %billing_name% a sua encomenda em %shop_name% encontra-se %order_status%. Obrigado',
			'es-es'   => 'Hola, %billing_name% su pedido en %shop_name% se encuentra %order_status%. Gracias',
			'default' => 'Hello, %billing_name% Your order at %shop_name% is %order_status%. Thank you'
		)
	);


	/**
	 * ControllerExtensionModuleSmartMarketing constructor.
	 *
	 * @param $registry
	 *
	 * @throws SoapFault
	 */
    public function __construct($registry)
    {
        parent::__construct($registry);

        // load API
        $this->api = new EgoiAPI($this->config->get('smart_marketing_api'));

        $this->set_modification = str_replace('&amp;', "&", $this->link('extension/modification/refresh'));

        // translations
        $this->load->language('extension/module/smart_marketing');

        $this->invalid_account = $this->config->get('smart_marketing_api') ? false : $this->language->get('invalid_account');
    }

    /**
     * Run on Module Install
     */
    public function install()
    {
        $this->load->model('extension/egoi/egoi');

        $this->model_extension_egoi_egoi->install($this->version);
    }

    /**
     * Check for Module Updates
     */
    public function checkUpdate()
    {
        $this->load->model('extension/egoi/egoi');

        $this->model_extension_egoi_egoi->update($this->version);


		$this->load->model('setting/setting');
		$this->model_setting_setting->editSetting('smart_marketing_sms', array('install_date' => date('Y-m-d H:i:s')));

    }

    /**
     * Configuration page
     */
    public function index()
    {
        $this->checkUpdate();

        $this->load->language('extension/module/smart_marketing');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('smart_marketing', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect(
                $this->link('extension/module/smart_marketing/account')
            );
        }

        // check
        $data['is_configuration'] = 1;

        $data['url_set_modification'] = $this->set_modification;
        $data['heading_title'] = $this->language->get('heading_title');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');
        $data['text_section_title'] = $this->language->get('text_section_config_title');
        $data['text_section_plugin_title_info'] = $this->language->get('text_section_plugin_title_info');
        $data['entry_api'] = $this->language->get('entry_api');
        $data['help_entry_api'] = $this->language->get('help_entry_api');

        // check for empty field error
        $data['empty_field'] = isset($this->error['field']) ? $this->error['field'] : null;

        // check for API errors
        $data['api_error'] = isset($this->error['api']) ? $this->error['api'] : null;

        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->link('common/dashboard')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->link('extension/extension')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->link('extension/module/smart_marketing')
        );

        $data['action'] = $this->link('extension/module/smart_marketing');
        $data['cancel'] = $this->link('extension/extension', '&type=module');

        if (isset($this->request->post['smart_marketing_api'])) {
            $data['smart_marketing_api'] = $this->request->post['smart_marketing_api'];
        } else {
            $data['smart_marketing_api'] = $this->config->get('smart_marketing_api');
        }

		$this->load->model('extension/egoi/egoi');

        $pluginInfo = $this->api->getPluginStatusData();

		$data['text_section_plugin_version']  = $this->language->get('text_section_plugin_version');
		$data['text_section_plugin_curl']     = $this->language->get('text_section_plugin_curl');
		$data['text_section_plugin_soap']     = $this->language->get('text_section_plugin_soap');
		$data['text_section_plugin_egoi_api'] = $this->language->get('text_section_plugin_egoi_api');

		$data['text_section_plugin_version_info'] = $pluginInfo['readable_version'];
		if(!empty($pluginInfo['required_update'])) {
			$data['text_section_plugin_version'] .= ' <i style="color:#de3333" class="fa fa-exclamation-triangle" aria-hidden="true"></i>';
			$data['text_section_plugin_version_info'] .= ' - ' . str_replace('%%VERSION%%', $pluginInfo['readable_available_version'], $this->language->get('text_section_plugin_new_version_info'));
		} else {
			$data['text_section_plugin_version_info'] .= ' <i style="color:#188426" class="fa fa-check" aria-hidden="true"></i>';
		}

		$data['text_section_plugin_curl_info'] = ' <i style="color:#188426" class="fa fa-check" aria-hidden="true"></i>';
		if(empty($pluginInfo['has_curl'])) {
			$data['text_section_plugin_curl'] .= ' <i style="color:#de3333" class="fa fa-exclamation-triangle" aria-hidden="true"></i>';
			$data['text_section_plugin_curl_info'] = ' <i style="color:#de3333" class="fa fa-times" aria-hidden="true"></i>';
		}

		$data['text_section_plugin_soap_info'] = ' <i style="color:#188426" class="fa fa-check" aria-hidden="true"></i>';
		if(empty($pluginInfo['has_soap'])) {
			$data['text_section_plugin_soap'] .= ' <i style="color:#de3333" class="fa fa-exclamation-triangle" aria-hidden="true"></i>';
			$data['text_section_plugin_soap_info'] = ' <i style="color:#de3333" class="fa fa-times" aria-hidden="true"></i>';
		}

		$data['text_section_plugin_egoi_api_info'] = ' <i style="color:#188426" class="fa fa-check" aria-hidden="true"></i>';
		if(empty($pluginInfo['apiv3'])) {
			$data['text_section_plugin_egoi_api'] .= ' <i style="color:#de3333" class="fa fa-exclamation-triangle" aria-hidden="true"></i>';
			$data['text_section_plugin_egoi_api_info'] = ' <i style="color:#de3333" class="fa fa-times" aria-hidden="true"></i>';
		}

        $this->loadTpl('extension/egoi/smart_marketing', $data);
    }

    /**
     * Account Page
     */
    public function account()
    {
        $this->checkUpdate();

        $this->load->model('extension/egoi/egoi');

        $data['invalid_account'] = $this->invalid_account;

        $data['heading_title'] = $this->language->get('heading_title');
        $data['url_set_modification'] = $this->set_modification;

        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->link('common/dashboard')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->link('extension/extension', '&type=module')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->link('extension/module/smart_marketing')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_section_account_title'),
            'href' => $this->link('extension/module/smart_marketing/account')
        );

        $data['text_section_title'] = $this->language->get('text_section_account_title');

        // get client data
        $client_data = $this->api->getClientData();

        $data['client_data'] = $client_data;

        $data['account_address'] = $this->language->get('account_address');
        $data['account_business_activity_code'] = $this->language->get('account_business_activity_code');
        $data['account_city'] = $this->language->get('account_city');
        $data['account_cliente_id'] = $this->language->get('account_cliente_id');
        $data['account_company_legal_name'] = $this->language->get('account_company_legal_name');
        $data['account_company_name'] = $this->language->get('account_company_name');
        $data['account_company_type'] = $this->language->get('account_company_type');
        $data['account_country'] = $this->language->get('account_country');
        $data['account_credits'] = $this->language->get('account_credits');
        $data['account_date_registration'] = $this->language->get('account_date_registration');
        $data['account_plan_email_limit'] = $this->language->get('account_plan_email_limit');
        $data['account_plan_email_sent'] = $this->language->get('account_plan_email_sent');
        $data['account_plan_push_limit'] = $this->language->get('account_plan_push_limit');
        $data['account_plan_push_sent'] = $this->language->get('account_plan_push_sent');
        $data['account_plan_sms_limit'] = $this->language->get('account_plan_sms_limit');
        $data['account_plan_sms_sent'] = $this->language->get('account_plan_sms_sent');
        $data['account_signup_date'] = $this->language->get('account_signup_date');
        $data['account_state'] = $this->language->get('account_state');
        $data['account_tax_id'] = $this->language->get('account_tax_id');
        $data['account_website'] = $this->language->get('account_website');
        $data['account_zip_code'] = $this->language->get('account_zip_code');

        $this->loadTpl('extension/egoi/smart_marketing_account', $data);
    }

	/**
	 * sends a sms test message
	 */
	public function send_admin_sms_notification() {

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {

			$this->load->model('extension/egoi/egoi');

			if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {

				if(empty($this->request->post['sender']) || empty($this->request->post['sendTo'])){
					echo json_encode(array("error" => true));
					return false;
				}

				$sendAdminSms = $this->api->sendSms(
					$this->request->post['sendTo'],
					$this->request->post['sender'],
					$this->language->get('text_section_smsnotification_sms_sender_demo_message'));

				echo $sendAdminSms;
				return true;
			}
		}

		echo json_encode(array("error" => true));
		return false;
	}

	/**
	 * Account Page
	 */
	public function sms_notification()
	{
		$this->checkUpdate();

		$this->load->model('extension/egoi/egoi');
		$this->load->model('setting/setting');
		$this->load->model('localisation/order_status');

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			return $this->saveSmsNotificationData();
		}

		$this->document->addStyle('view/javascript/codemirror/theme/monokai.css');

		$data['invalid_account'] = $this->invalid_account;

		//breadcrumbs
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->link('extension/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->link('extension/module/smart_marketing')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_section_smsnotification_title'),
			'href' => $this->link('extension/module/smart_marketing/sms_notification')
		);

		//routes
		$data['cancel'] = $this->link('extension/module/smart_marketing/sms_notification');
		$data['form_action'] = $this->link('extension/module/smart_marketing/sms_notification');
		$data['send_admin_test_action'] = $this->link('extension/module/smart_marketing/send_admin_sms_notification');

		//translations
		$data['heading_title'] = $this->language->get('text_section_smsnotification_title');
		$data['text_section_smsnotification_general_settings_title'] = $this->language->get('text_section_smsnotification_general_settings_title');
		$data['text_section_smsnotification_general_settings_info_title'] = $this->language->get('text_section_smsnotification_general_settings_info_title');
		$data['text_section_smsnotification_general_settings_info_title_balance'] = $this->language->get('text_section_smsnotification_general_settings_info_title_balance');
		$data['text_section_smsnotification_sms_messages_title'] = $this->language->get('text_section_smsnotification_sms_messages_title');
		$data['text_section_smsnotification_payment_reminders_title'] = $this->language->get('text_section_smsnotification_payment_reminders_title');
		$data['text_section_smsnotification_help_title'] = $this->language->get('text_section_smsnotification_help_title');
		$data['text_section_smsnotification_select_sms_sender'] = $this->language->get('text_section_smsnotification_select_sms_sender');
		$data['text_section_smsnotification_select_admin_sender'] = $this->language->get('text_section_smsnotification_select_admin_sender');
		$data['text_section_smsnotification_select_sms_sender_send_text'] = $this->language->get('text_section_smsnotification_select_sms_sender_send_text');
		$data['text_section_smsnotification_select_sms_sender_send_text_success'] = $this->language->get('text_section_smsnotification_select_sms_sender_send_text_success');
		$data['text_section_smsnotification_select_sms_sender_send_text_error'] = $this->language->get('text_section_smsnotification_select_sms_sender_send_text_error');
		$data['text_section_smsnotification_select_sms_sender_send_text_message_send_error'] = $this->language->get('text_section_smsnotification_select_sms_sender_send_text_message_send_error');
		$data['text_section_smsnotification_select_sms_notifications'] = $this->language->get('text_section_smsnotification_select_sms_notifications');
		$data['text_section_smsnotification_select_sms_notifications_description'] = $this->language->get('text_section_smsnotification_select_sms_notifications_description');
		$data['text_section_smsnotification_select_sms_notifications_order_status'] = $this->language->get('text_section_smsnotification_select_sms_notifications_order_status');
		$data['text_section_smsnotification_select_sms_notifications_order_status_customer'] = $this->language->get('text_section_smsnotification_select_sms_notifications_order_status_customer');
		$data['text_section_smsnotification_select_sms_notifications_order_status_admin'] = $this->language->get('text_section_smsnotification_select_sms_notifications_order_status_admin');
		$data['text_section_smsnotification_select_sms_notifications_order_status_reminder'] = $this->language->get('text_section_smsnotification_select_sms_notifications_order_status_reminder');
		$data['text_section_smsnotification_select_notifications_languages_title'] = $this->language->get('text_section_smsnotification_select_notifications_languages_title');
		$data['text_section_smsnotification_select_notifications_languages_description'] = $this->language->get('text_section_smsnotification_select_notifications_languages_description');
		$data['text_section_smsnotification_help_header'] = $this->language->get('text_section_smsnotification_help_header');
		$data['text_section_smsnotification_help_header_info'] = $this->language->get('text_section_smsnotification_help_header_info');
		$data['text_section_smsnotification_send_to_who'] = $this->language->get('text_section_smsnotification_send_to_who');
		$data['text_section_smsnotification_send_to_who_all'] = $this->language->get('text_section_smsnotification_send_to_who_all');
		$data['text_section_smsnotification_send_to_who_checked'] = $this->language->get('text_section_smsnotification_send_to_who_checked');
		$data['text_section_smsnotification_select_reminder_interval'] = $this->language->get('text_section_smsnotification_select_reminder_interval');
		$data['text_section_smsnotification_select_notifications_languages'] = $this->language->get('text_section_smsnotification_select_notifications_languages');
		$data['text_section_smsnotification_select_notifications_languages_option'] = $this->language->get('text_section_smsnotification_select_notifications_languages_option');
		$data['text_section_smsnotification_select_reminders_languages_title'] = $this->language->get('text_section_smsnotification_select_reminders_languages_title');
		$data['text_section_smsnotification_select_reminders_languages_description'] = $this->language->get('text_section_smsnotification_select_reminders_languages_description');
		$data['text_section_smsnotification_general_settings_error_saving'] = $this->language->get('text_section_smsnotification_select_reminders_languages_description');
		$data['text_section_smsnotification_general_settings_success_saving'] = $this->language->get('text_section_smsnotification_select_reminders_languages_description');
		$data['text_section_smsnotification_sms_tracking_url_title'] = $this->language->get('text_section_smsnotification_sms_tracking_url_title');
		$data['text_section_smsnotification_select_sms_tracking_url_second_title'] = $this->language->get('text_section_smsnotification_select_sms_tracking_url_second_title');
		$data['text_section_smsnotification_select_sms_tracking_url_description'] = $this->language->get('text_section_smsnotification_select_sms_tracking_url_description');
		$data['text_section_smsnotification_select_sms_tracking_url_courier'] = $this->language->get('text_section_smsnotification_select_sms_tracking_url_courier');
		$data['text_section_smsnotification_select_sms_tracking_url_url'] = $this->language->get('text_section_smsnotification_select_sms_tracking_url_url');

		//rest os data
		$senders_data = $this->api->getSmsSenders();
		$account_data = $this->api->getAccountData();
		$data['account_data'] = array();

		if(!empty($account_data)){
			$account_data = json_decode($account_data, true);
			if(!empty($account_data["general_info"])){
				$data['account_data'] = $account_data;
			}
		}

		$data['senders_data'] = $senders_data;
		$data['reminder_interval'] = $this->reminder_interval;

		$available_languages = $this->db->query("SELECT * from " . DB_PREFIX . "language");
		$data['languages'] = $available_languages->rows;
		$data['egoi_templateing'] = $this->egoiTemplating;

		$data['smart_marketing_sms_notifications_admin_cellphone'] = !empty($this->config->get('smart_marketing_sms_notifications_admin_cellphone')) ? $this->config->get('smart_marketing_sms_notifications_admin_cellphone') : '';
		$data['smart_marketing_sms_notifications_sms_sender'] = !empty($this->config->get('smart_marketing_sms_notifications_sms_sender')) ? $this->config->get('smart_marketing_sms_notifications_sms_sender') : '';
		$data['smart_marketing_sms_notifications_admin_sender'] = !empty($this->config->get('smart_marketing_sms_notifications_admin_sender')) ? $this->config->get('smart_marketing_sms_notifications_admin_sender') : '';
		$data['smart_marketing_sms_reminders_statuses'] = !empty($this->config->get('smart_marketing_sms_reminders_statuses')) ? $this->config->get('smart_marketing_sms_reminders_statuses') : '';

		//build available_notifications tree
		$order_statuses = $this->model_localisation_order_status->getOrderStatuses();

		foreach ($order_statuses as $os) {
			$this->available_notifications[$os['order_status_id']] = array(
					'label'                             => $os['name'],
					'customer'                          => array(
						'field' => 'smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_enable',
						'value' => !empty($this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_enable')) ? $this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_enable') : 0
					),
					'admin'                             => array(
						'field' => 'smart_marketing_sms_notifications_'.$os['order_status_id'].'_admin_enable',
						'value' => !empty($this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_admin_enable')) ? $this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_admin_enable') : 0
					),
					'reminder'                             => array(
						'field' => 'smart_marketing_sms_notifications_'.$os['order_status_id'].'_reminder_enable',
						'value' => !empty($this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_reminder_enable')) ? $this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_reminder_enable') : 0
					)
			);

			foreach ($data['languages'] as $language) {
				$this->available_notifications[$os['order_status_id']]['default_message_customer'][$language['code']] = array(
					'field' => 'smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_message_'.$language['code'],
					'code' => $language['code'],
					'value' => !empty($this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_message_'.$language['code'])) ? $this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_message_'.$language['code']) : (!empty($this->defaultMessages['default'][$language['code']]) ? $this->defaultMessages['default'][$language['code']] : $this->defaultMessages['default']['default'])
				);

				$this->available_notifications[$os['order_status_id']]['default_message_customer_reminder'][$language['code']] = array(
					'field' => 'smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_message_reminder_'.$language['code'],
					'code' => $language['code'],
					'value' => !empty($this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_message_reminder_'.$language['code'])) ? $this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_customer_message_reminder_'.$language['code']) : (!empty($this->defaultMessages['reminders'][$language['code']]) ? $this->defaultMessages['reminders'][$language['code']] : $this->defaultMessages['reminders']['default'])
				);

				$this->available_notifications[$os['order_status_id']]['default_message_admin'][$language['code']] = array(
					'field' => 'smart_marketing_sms_notifications_'.$os['order_status_id'].'_admin_message_'.$language['code'],
					'code' => $language['code'],
					'value' => !empty($this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_admin_message_'.$language['code'])) ? $this->config->get('smart_marketing_sms_notifications_'.$os['order_status_id'].'_admin_message_'.$language['code']) : ''
				);
			}
		}

		foreach ($this->egoiTemplating as $k=>$egoiTemplating) {
			$this->egoiTemplating[$k]['label'] = $this->language->get($this->egoiTemplating[$k]['label']);
		}

		foreach ($this->helpoc as $k => $v) {
			$this->helpoc[$k]['title'] = $this->language->get($v['title']);
			$this->helpoc[$k]['description'] = $this->language->get($v['description']);
		}

		$data['available_notifications'] = $this->available_notifications;
		$data['default_messages']        = $this->defaultMessages;
		$data['egoi_templating']         = $this->egoiTemplating;
		$data['egoi_help']               = $this->helpoc;
		$data['order_statuses']          = $order_statuses;

		$data['smart_marketing_sms_notifications_send_to_who'] = !empty($this->config->get('smart_marketing_sms_notifications_send_to_who')) ? $this->config->get('smart_marketing_sms_notifications_send_to_who') : 'all';
		$data['smart_marketing_sms_notifications_reminder_interval'] = !empty($this->config->get('smart_marketing_sms_notifications_reminder_interval')) ? $this->config->get('smart_marketing_sms_notifications_reminder_interval') : '12';

		//new courier stuff
		$available_couriers = $this->db->query("SELECT sc.shipping_courier_id, sc.shipping_courier_code, sc.shipping_courier_name, sc.shipping_courier_tracking_uri FROM `" . DB_PREFIX . "shipping_courier` sc");
		$data['available_couriers'] = $available_couriers->rows;

		$this->loadTpl('extension/egoi/smart_marketing_smsnotification', $data);
	}


	/**
	 * trackengage sync page
	 */
	public function trackengage()
	{
		$this->checkUpdate();

		$this->load->model('extension/egoi/egoi');
		$this->load->model('setting/setting');

		// define links
		$data['action'] = $this->link('extension/module/smart_marketing/trackengage');

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {

			// save global settings to DB
			$request = $this->request->post;

			$request['smart_marketing_subscribers_auto_sync'] = !empty($this->config->get('smart_marketing_subscribers_auto_sync')) ? $this->config->get('smart_marketing_subscribers_auto_sync') : 0;
			$request['smart_marketing_subscribers_sync_with_list'] = !empty($this->config->get('smart_marketing_subscribers_sync_with_list')) ? $this->config->get('smart_marketing_subscribers_sync_with_list') : 0;
			$request['smart_marketing_subscribers_customer_group'] = !empty($this->config->get('smart_marketing_subscribers_customer_group')) ? $this->config->get('smart_marketing_subscribers_customer_group') : 0;

			$this->model_setting_setting->editSetting('smart_marketing_subscribers', $request);

			// check and save status to DB - it is necessary this part for getting Track&Engage code
			$status = isset($request['smart_marketing_subscribers_track_and_engage']) ? $request['smart_marketing_subscribers_track_and_engage'] : '0';
			$this->model_setting_setting->editSetting('module_smart_marketing_subscribers',
													  [
													  	'module_smart_marketing_subscribers_status' => $status
													  ]
			);

			// enable Track&Engage
			$this->model_extension_egoi_egoi->activateTrackAndEngage($status, 'smart_marketing_subscribers');

			$data['success'] = $this->language->get('trackengage_saved_success');
		}
		$this->document->addStyle('view/javascript/codemirror/theme/monokai.css');

		$data = array();
		$data['invalid_account'] = $this->invalid_account;

		//breadcrumbs
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->link('extension/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->link('extension/module/smart_marketing')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_section_trackengage_title'),
			'href' => $this->link('extension/module/smart_marketing/trackengage')
		);

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['option_no'] = $this->language->get('option_no');
		$data['option_yes'] = $this->language->get('option_yes');
		$data['help_track_and_engage'] = $this->language->get('help_track_and_engage');
		$data['text_track_and_engage_section_title'] = $this->language->get('text_track_and_engage_section_title');
		$data['entry_track_and_engage'] = $this->language->get('entry_track_and_engage');
		$data['text_trackengage_info'] = $this->language->get('trackengage_info');

		if (isset($this->request->post['smart_marketing_subscribers_track_and_engage'])) {
			$data['smart_marketing_subscribers_track_and_engage'] = $this->request->post['smart_marketing_subscribers_track_and_engage'];
		} else {
			$data['smart_marketing_subscribers_track_and_engage'] = $this->config->get('smart_marketing_subscribers_track_and_engage');
		}

		if (isset($this->request->post['smart_marketing_subscribers_track_and_engage'])) {
			$data['smart_marketing_subscribers_track_and_engage'] = $this->request->post['smart_marketing_subscribers_track_and_engage'];
		} else {
			$data['smart_marketing_subscribers_track_and_engage'] = $this->config->get('smart_marketing_subscribers_track_and_engage');
		}

		$this->loadTpl('extension/egoi/smart_marketing_trackengage', $data);

	}

	/**
	 * Ecommerce sync page
	 */
	public function ecommerce()
	{
		$this->checkUpdate();

		$data = array();

		$this->load->model('extension/egoi/egoi');

		$data['delete_success'] = false;

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {

			$request = $this->request->post;

			if ( !empty($this->request->server['HTTP_X_REQUESTED_WITH']) && strtolower($this->request->server['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest' )
			{
				if(!empty($request['method'])){

					switch ($request['method']) {
						case 'new_catalog':
							$data = array(
								'title' => 'Opencart ' . filter_var($request['catalog_title'], FILTER_SANITIZE_STRING),
								'language' => strtolower(filter_var($request['catalog_language'], FILTER_SANITIZE_STRING)),
								'currency' => strtolower(filter_var($request['catalog_currency'], FILTER_SANITIZE_STRING)),
							);

							$newCatalog = $this->api->postEcommerceCatalogs($data);
							$opencartCatalogIds = $this->config->get('smart_marketing_catalogs_ids');
							$opencartCatalogSync = $this->config->get('smart_marketing_catalogs_sync');

							if(!empty($newCatalog)){
								$newCatalog = json_decode($newCatalog, true);
							}

							if(!empty($opencartCatalogIds)){
								$opencartCatalogIds = explode(',', $opencartCatalogIds);
							} else {
								$opencartCatalogIds = array();
							}

							$opencartCatalogIds[] = $newCatalog['catalog_id'];

							$this->model_setting_setting->editSetting(
								'smart_marketing_catalogs',
								array(
									'smart_marketing_catalogs_ids' => implode(',', $opencartCatalogIds),
									'smart_marketing_catalogs_sync' => $opencartCatalogSync
								)
							);


							echo json_encode(array('status' => 'success'));
							break;
					}

				}

				return true;
			}  elseif(!empty($request['method']) && !empty($request['catalogId']) && $request['method'] == 'deleteCatalog') {

				$this->api->deleteEcommerceCatalogs($request['catalogId']);

				$opencartCatalogIds = $this->config->get('smart_marketing_catalogs_ids');
				$opencartCatalogSync = $this->config->get('smart_marketing_catalogs_sync');

				if(!empty($opencartCatalogIds)){
					$opencartCatalogIds = explode(',', $opencartCatalogIds);
					foreach ($opencartCatalogIds as $k => $v) {
						if($v == $request['catalogId']){
							unset($opencartCatalogIds[$k]);
						}
					}
				} else {
					$opencartCatalogIds = array();
				}

				if(!empty($opencartCatalogSync)){
					$opencartCatalogSync = json_decode($opencartCatalogSync, true);
					foreach ($opencartCatalogSync as $k => $v) {
						if($v == $request['catalogId']){
							unset($opencartCatalogSync[$k]);
						}
					}
				} else {
					$opencartCatalogSync = array();
				}

				$this->model_setting_setting->editSetting(
					'smart_marketing_catalogs',
					array(
						'smart_marketing_catalogs_ids' => implode(',', $opencartCatalogIds),
						'smart_marketing_catalogs_sync' => json_encode($opencartCatalogSync)
					)
				);

				$data['delete_success'] = true;
				$data['text_column_catalog_delete_success'] = $this->language->get('text_column_catalog_delete_success');

			}
		}

		$this->document->addStyle('view/javascript/codemirror/theme/monokai.css');


		$data['invalid_account'] = $this->invalid_account;

		//breadcrumbs
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->link('common/dashboard')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->link('extension/extension', '&type=module')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->link('extension/module/smart_marketing')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_section_ecommerce_title'),
			'href' => $this->link('extension/module/smart_marketing/ecommerce')
		);

		$data['text_section_title']                    = $this->language->get('text_section_ecommerce_title');
		$data['text_column_id_catalog']                = $this->language->get('text_column_id_catalog');
		$data['text_column_titulo_catalog']            = $this->language->get('text_column_titulo_catalog');
		$data['text_column_language_catalog']          = $this->language->get('text_column_language_catalog');
		$data['text_column_currency_catalog']          = $this->language->get('text_column_currency_catalog');
		$data['text_column_lastupdated_catalog']       = $this->language->get('text_column_lastupdated_catalog');
		$data['text_column_options_catalog']           = $this->language->get('text_column_options_catalog');
		$data['text_column_options_created_at']        = $this->language->get('text_column_options_created_at');
		$data['text_column_options_created_egoi']      = $this->language->get('text_column_options_created_egoi');
		$data['text_column_options_created_opencart']  = $this->language->get('text_column_options_created_opencart');
		$data['text_column_new_catalog']               = $this->language->get('text_column_new_catalog');
		$data['text_column_new_catalog_label']         = $this->language->get('text_column_new_catalog_label');
		$data['text_column_catalog_delete']            = $this->language->get('text_column_catalog_delete');
		$data['text_column_catalog_sync']              = $this->language->get('text_column_catalog_sync');
		$data['text_column_catalog_sync_info']         = $this->language->get('text_column_catalog_sync_info');
		$data['text_column_catalog_sync_close_button'] = $this->language->get('text_column_catalog_sync_close_button');
		$data['text_column_catalog_sync_close_done']   = $this->language->get('text_column_catalog_sync_close_done');

		$data['action'] = str_replace('&amp;', "&", $this->link('extension/module/smart_marketing/ecommerce'));
		$data['action_get_catalogue_data'] = str_replace('&amp;', "&", $this->link('extension/module/smart_marketing/loadCatalogData'));
		$data['action_get_sync_catalogue_data'] = str_replace('&amp;', "&", $this->link('extension/module/smart_marketing/getSyncCatalogData'));
		$data['action_sync_catalogue_data'] = str_replace('&amp;', "&", $this->link('extension/module/smart_marketing/syncCatalogData'));

		$data['catalogs'] = array();
		$data['countries'] = array();
		$data['currency'] = array();
		$data['opencartCatalogIds'] = array();

		$countries = $this->api->getCountrysAndCurrencys();
		$catalogs = $this->api->getEcommerceCatalogs();

		$opencartCatalogIds = $this->config->get('smart_marketing_catalogs_ids');
		$opencartCatalogSync = $this->config->get('smart_marketing_catalogs_sync');

		if(!empty($opencartCatalogIds)){
			$opencartCatalogIds = explode(',', $opencartCatalogIds);
		}

		if(!empty($opencartCatalogSync)){
			$opencartCatalogSync = json_decode($opencartCatalogSync, true);
		}

		if (!empty($catalogs)) {
			$catalogs = json_decode($catalogs, true);
			if (!empty($catalogs['items'])) {
				$catalogs = $catalogs['items'];

				foreach ($catalogs as $k=>$v) {
					$catalogs[$k]['created_at'] = $this->language->get('text_column_options_created_egoi');
					if(!empty($opencartCatalogIds)){
						foreach ($opencartCatalogIds as $opencartCatalogId) {
							if($opencartCatalogId == $v['catalog_id']){
								$catalogs[$k]['created_at'] = $this->language->get('text_column_options_created_opencart');
							}
						}
					}

					$catalogs[$k]['sync'] = '';

					if(!empty($opencartCatalogSync)){
						foreach ($opencartCatalogSync as $key => $value) {
							if($key == $v['catalog_id']){
								$catalogs[$k]['sync'] = $value;
							}
						}
					}
				}
				$data['catalogs'] = $catalogs;
			}
		}

		if (!empty($countries)) {
			$countries = json_decode($countries, true);
			if (!empty($countries['items'])) {
				$data['countries'] = $countries['items'];
			}
		}

		foreach ($data['countries'] as $country) {
			$data['currency'][] = $country['currency'];
		}

		$data['currency'] = array_unique($data['currency']);

		$this->loadTpl('extension/egoi/smart_marketing_ecommerce', $data);

	}

	/**
	 *
	 */
	public function loadCatalogData()
	{

		if(!empty($this->request->get['catalog'])){
			$data = array();
			$dataLocked = false;

			$opencartCatalogSync = $this->config->get('smart_marketing_catalogs_sync');

			$available_languages = $this->db->query("SELECT * from " . DB_PREFIX . "language");
			$data['languages'] = $available_languages->rows;

			$available_stores = $this->db->query("SELECT * from " . DB_PREFIX . "store");

			$data['stores'][] = array(
				"store_id" => 0,
				"name" => 'Default',
				"url" => 'default',
				"ssl" => 0,

			);

			if(!empty($available_stores->rows)){
				$data['stores'] = array_merge($data['stores'], $available_stores->rows);
			}

			$data['locked'] = $dataLocked;

			$data['status'] = 'success';

			echo json_encode($data);

		} else {
			echo json_encode(array('status' => 'error'));
		}
	}

	/**
	 * @param int $offset
	 *
	 * @return bool
	 */
	public function syncCatalogData($offset=0) {

		if(!empty($this->request->get['catalog']) && array_key_exists('storeId', $this->request->get) && !empty($this->request->get['langId'])) {

			$this->load->model('setting/setting');
			$this->load->model('tool/image');

			$catalogId = $this->request->get['catalog'];

			$lang = (!empty($this->request->get['langId']) ? $this->request->get['langId'] : 1);

			$limit = 100;
			if(!empty($this->request->get['offset'])){
				$offset = $this->request->get['offset'];
			}

			if(!empty($this->request->get['limit'])){
				$limit = $this->request->get['limit'];
			}

			$data = array(
				'products' => array(),
				'mode' => 'update'
			);

			$productsQuery = $this->db->query("
				SELECT 
				ps.product_id,
				p.sku, p.upc, p.ean, p.mpn, p.image as image_link, p.price,
				pd.`name`, pd.description,
				pm.`name` as brand,
				tc.tax_class_id, 
				CONCAT('?route=product/product&product_id=', ps.product_id) as link 
				FROM " . DB_PREFIX . "product_to_store ps 
				left join " . DB_PREFIX . "product p on p.product_id = ps.product_id
				left join " . DB_PREFIX . "product_description pd on p.product_id = pd.product_id
				left join " . DB_PREFIX . "manufacturer pm on p.manufacturer_id = pm.manufacturer_id 
				left join " . DB_PREFIX . "tax_class tc on p.tax_class_id = tc.tax_class_id 
				WHERE ps.store_id=" . (!empty($this->request->get['storeId']) ? $this->request->get['storeId'] : 0) ." AND pd.language_id=". $lang . " 
				LIMIT " . $offset . ", " . $limit
			);

			if(!empty($productsQuery->rows)) {

				$products = $productsQuery->rows;

				//GET CATEGORIES
				$productsCategoriesQuery = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_to_category");
				$breadCrumbs = array();
				if(!empty($productsCategoriesQuery->rows)) {
					$categoriesToProducts = $productsCategoriesQuery->rows;
					foreach ($categoriesToProducts as $categoriesToProduct) {
						if(empty($breadCrumbs['category_'.$categoriesToProduct['category_id']])) {
							$breadCrumbs['category_' . $categoriesToProduct['category_id']] = $this->getCategoryTree($categoriesToProduct['category_id'], $lang);
						}
					}
				}

				$productsRelatedQuery = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_related");
				$relatedProducts = array();
				if(!empty($productsRelatedQuery->rows)) {
					$relatedProductsRows = $productsRelatedQuery->rows;
					foreach ($relatedProductsRows as $relatedProduct) {
						$relatedProducts['product_' . $relatedProduct['product_id']] = $relatedProduct['related_id'];
					}
				}

				$productsSaleQuery = $this->db->query("SELECT product_id, MIN(price) sale_price FROM " . DB_PREFIX . "product_special GROUP BY product_id");
				$sales = array();
				if(!empty($productsSaleQuery->rows)) {
					$productsSaleRows = $productsSaleQuery->rows;

					foreach ($productsSaleRows as $productsSaleRow) {
						$sales['product_' . $productsSaleRow['product_id']] = $productsSaleRow['sale_price'];
					}
				}

                // TAX CALCULATION
                $tax = [];
                $taxRuleQuery = $this->db->query("SELECT * FROM " . DB_PREFIX . "tax_rule");
                if(!empty($taxRuleQuery->rows)) {
                    $taxRuleRows = $taxRuleQuery->rows;
                    $taxes = [];
                    foreach ($taxRuleRows as $taxRuleRow) {
                        $taxes[] = ['class' => $taxRuleRow['tax_class_id'], 'rate' => $taxRuleRow['tax_rate_id']];
                    }

                    if(!empty($taxes)){
                        foreach ($taxes as $t) {
                            $taxRateQuery = $this->db->query("SELECT rate FROM " . DB_PREFIX . "tax_rate WHERE `type`='P' and tax_rate_id=".$t['rate']);
                            if(!empty($taxRateQuery->rows)) {
                                $taxRateRows = $taxRateQuery->rows;
                                foreach ($taxRateRows as $taxRateRow) {
                                    $tax[] = [
                                        'class' => $t['class'],
                                        'rate' => $t['rate'],
                                        'value' => $taxRateRow['rate'],
                                        'value_percent' => (($taxRateRow['rate']/100)+1),
                                    ];
                                }
                            }
                        }
                    }
                }

				foreach ($products as $product) {
				    $taxCalculated = false;
					$category = array();
					$productsCategoriesQuery = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_to_category WHERE product_id=".$product['product_id']);
					if(!empty($productsCategoriesQuery->rows)) {
						$categoriesToProducts = $productsCategoriesQuery->rows;
						foreach ($categoriesToProducts as $categoriesToProduct) {
							$category[] = implode(' > ', $breadCrumbs['category_' . $categoriesToProduct['category_id']]);
						}
					}

					$price = !empty($product['price']) ? $product['price'] : 0;

					if(!empty($tax)){
                        foreach ($tax as $taxes) {
                            if(!empty($taxCalculated)) {
                                continue;
                            }
                            if($product['tax_class_id'] == $taxes['class']){
                                $price = $price * $taxes['value_percent'];
                                $taxCalculated = true;
                            }
                        }
                    }

					$data['products'][] = array(
						"product_identifier" => $product['product_id'],
						"name" => $product['name'],
						"description" => $product['description'],
						"sku" => $product['sku'],
						"upc" => $product['upc'],
						"ean" => $product['ean'],
						"gtin" => '',
						"mpn" => $product['mpn'],
						"link" => HTTP_CATALOG.$product['link'],
						"image_link" => $product_info['image_url'] = $this->model_tool_image->resize($product['image_link'], 800, 800),
						"price" => $price,
						"sale_price" => !empty($sales['product_' . $product['product_id']]) ? $sales['product_' . $product['product_id']] : 0,
						"brand" => $product['brand'],
						"categories" => (!empty($category) ? $category : array()),
						"related_products" => (!empty($relatedProducts['product_' . $product['product_id']]) ? $relatedProducts['product_' . $product['product_id']] : array()),
					);
				}

				if(!empty($data)){
					$this->api->importCatalog($catalogId, $data);

					$opencartCatalogIds = $this->config->get('smart_marketing_catalogs_ids');
					$opencartCatalogSync = $this->config->get('smart_marketing_catalogs_sync');

					if(!empty($opencartCatalogSync)){
						$opencartCatalogSync = json_decode($opencartCatalogSync, true);
					} else {
						$opencartCatalogSync = array();
					}

					$opencartCatalogSync[$catalogId] = date('Y-m-d H:i:s');

					$this->model_setting_setting->editSetting(
						'smart_marketing_catalogs',
						array(
							'smart_marketing_catalogs_ids' => $opencartCatalogIds,
							'smart_marketing_catalogs_sync' => json_encode($opencartCatalogSync)
						)
					);



				}

			}

			echo json_encode(
				array(
					'status' => 'success',
					'num' => count($data['products']),
				)
			);
			return true;





		} else {
			echo json_encode(array('status' => 'error'));
		}

	}

	/**
	 * @param $cat
	 * @param int $lang
	 *
	 * @return array
	 */
	protected function getCategoryTree($cat, $lang=1) {

		$breadcrumb = array();

		$productsCategoriesQuery = $this->db->query("
					SELECT cd.category_id, cd.`name`, c.parent_id 
					FROM " . DB_PREFIX . "category_description cd 
					left join " . DB_PREFIX . "category c on c.category_id = cd.category_id
					WHERE cd.category_id=".$cat." AND cd.language_id=".$lang
				);

		if(!empty($productsCategoriesQuery->rows)) {
			$row = $productsCategoriesQuery->rows;
			$breadcrumb[] = $row[0]['name'];

			$breadcrumb = array_merge($this->getCategoryTree($row[0]['parent_id']), $breadcrumb);
		}

		return $breadcrumb;

	}

	/**
	 *
	 */
	public function getSyncCatalogData()
	{
		if(!empty($this->request->get['catalog']) && array_key_exists('storeId', $this->request->get) && !empty($this->request->get['langId'])) {


			$productsNumQuery = $this->db->query("SELECT count(product_id) num FROM " . DB_PREFIX . "product_to_store WHERE store_id=" . (!empty($this->request->get['storeId']) ? $this->request->get['storeId'] : 0));

			$productsNum = $productsNumQuery->rows;

			if(empty($productsNum[0]['num'])){
				echo json_encode(array('status' => 'no_products'));
				return true;
			}

			echo json_encode(
				array(
					'status' => 'success',
					'num' => $productsNum[0]['num'],
					)
			);
			return true;

		} else {
			echo json_encode(array('status' => 'error'));
		}
	}


    /**
     * Lists Page
     */
    public function lists()
    {
        $this->checkUpdate();

        $this->load->model('extension/egoi/egoi');

        $data['invalid_account'] = $this->invalid_account;

        $data['heading_title'] = $this->language->get('heading_title');
        $data['url_set_modification'] = $this->set_modification;

        // validate POST request
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate("lists")) {

            // create a new list
            $result = $this->api->createList(
                $this->request->post['smart_marketing_list_name'],
                $this->request->post['smart_marketing_lang']
            );

            if(isset($result['ERROR'])) {
                $data['success'] = '';
                $data['error'] = $result['ERROR'];
            } else {
                $data['success'] = $this->language->get('list_added_success');
                $data['error'] = '';
            }
        }

        // check for errors
        $data['error'] = isset($this->session->data['error']) ? $this->session->data['error'] : null;

        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->link('common/dashboard')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->link('extension/extension', '&type=module')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->link('extension/module/smart_marketing')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_section_lists_title'),
            'href' => $this->link('extension/module/smart_marketing/lists')
        );

        $data_list = $this->getLists();
        $data = array_merge($data, $data_list);

        $data_form = $this->getFormCustomVars();
        $data = array_merge($data, $data_form);

        $this->loadTpl('extension/egoi/smart_marketing_lists', $data);
    }

    /**
     * Subscribers Page
     */
    public function subscribers()
    {
        $this->load->model('customer/customer');
        $this->load->model('customer/customer_group');
        $this->load->model('extension/egoi/egoi');
        $this->load->model('setting/setting');

        $this->checkUpdate();

        $data['invalid_account'] = $this->invalid_account;

        // define links
        $data['action'] = $this->link('extension/module/smart_marketing/subscribers');
        $data['url_set_modification'] = $this->set_modification;
        $data['url_sync_subscribers'] = str_replace('&amp;', "&", $this->link('extension/module/smart_marketing/syncSubscribers'));

        if ($this->request->server['REQUEST_METHOD'] == 'POST') {

            // save global settings to DB
            $request = $this->request->post;

			$request['smart_marketing_subscribers_track_and_engage'] = !empty($this->config->get('smart_marketing_subscribers_track_and_engage')) ? $this->config->get('smart_marketing_subscribers_track_and_engage') : '0';

            $this->model_setting_setting->editSetting('smart_marketing_subscribers', $request);

            // check and save status to DB - it is necessary this part for getting Track&Engage code
            $status = isset($request['smart_marketing_subscribers_track_and_engage']) ?
                $request['smart_marketing_subscribers_track_and_engage'] : '0';
            $this->model_setting_setting->editSetting('module_smart_marketing_subscribers', [
                    'module_smart_marketing_subscribers_status' => $status]
            );

            // enable Track&Engage
            $this->model_extension_egoi_egoi->activateTrackAndEngage($status, 'smart_marketing_subscribers');

            $data['success'] = $this->language->get('subscribers_saved_success');
        }

        $data['heading_title'] = $this->language->get('heading_title');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->link('common/dashboard')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->link('extension/extension', '&type=module')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->link('extension/module/smart_marketing')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_section_subscribers_title'),
            'href' => $this->link('extension/module/smart_marketing/subscribers')
        );

        $data['text_section_title'] = $this->language->get('text_section_subscribers_title');
        $data['help_auto_sync'] = $this->language->get('help_auto_sync');
        $data['option_no'] = $this->language->get('option_no');
        $data['option_yes'] = $this->language->get('option_yes');
        $data['entry_auto_sync'] = $this->language->get('entry_auto_sync');
        $data['help_sync_with_list'] = $this->language->get('help_sync_with_list');
        $data['entry_sync_with_list'] = $this->language->get('entry_sync_with_list');
        $data['option_all_profiles'] = $this->language->get('option_all_profiles');
        $data['entry_smart_marketing_customer_group'] = $this->language->get('entry_smart_marketing_customer_group');
        $data['help_smart_marketing_customer_group'] = $this->language->get('help_smart_marketing_customer_group');
        $data['text_auto_sync_section_title'] = $this->language->get('text_auto_sync_section_title');
        $data['help_track_and_engage'] = $this->language->get('help_track_and_engage');
        $data['text_track_and_engage_section_title'] = $this->language->get('text_track_and_engage_section_title');
        $data['entry_track_and_engage'] = $this->language->get('entry_track_and_engage');
        $data['entry_auto_sync_egoi'] = $this->language->get('entry_auto_sync_egoi');
        $data['entry_auto_sync_opencart'] = $this->language->get('entry_auto_sync_opencart');
        $data['button_sync_contacts'] = $this->language->get('button_sync_contacts');
        $data['help_contacts_sync_egoi'] = $this->language->get('help_contacts_sync_egoi');
        $data['help_contacts_sync_oc'] = $this->language->get('help_contacts_sync_oc');

        $lists = $this->api->getLists();
        $data['lists'] = $lists;

        $data['customer_groups'] = $this->model_customer_customer_group->getCustomerGroups();

        if (isset($this->request->post['smart_marketing_subscribers_auto_sync'])) {
            $data['smart_marketing_subscribers_auto_sync'] = $this->request->post['smart_marketing_subscribers_auto_sync'];
        } else {
            $data['smart_marketing_subscribers_auto_sync'] = $this->config->get('smart_marketing_subscribers_auto_sync');
        }

        if (isset($this->request->post['smart_marketing_subscribers_sync_with_list'])) {
            $data['smart_marketing_subscribers_sync_with_list'] = $this->request->post['smart_marketing_subscribers_sync_with_list'];
        } else {
            $data['smart_marketing_subscribers_sync_with_list'] = $this->config->get('smart_marketing_subscribers_sync_with_list');
        }

        if (isset($this->request->post['smart_marketing_subscribers_customer_group'])) {
            $data['smart_marketing_subscribers_customer_group'] = $this->request->post['smart_marketing_subscribers_customer_group'];
        } else {
            $data['smart_marketing_subscribers_customer_group'] = $this->config->get('smart_marketing_subscribers_customer_group');
        }

        $data_filter = array();

        if(isset($data['smart_marketing_subscribers_customer_group']) && $data['smart_marketing_subscribers_customer_group'] > 0){
            $data_filter["filter_customer_group_id"] = $data['smart_marketing_subscribers_customer_group'];
        }

        $data['auto_sync_opencart'] = $this->model_customer_customer->getTotalCustomers($data_filter);
        $data['auto_sync_egoi'] = 0;

        // get subscribers counts
        if(isset($data['smart_marketing_subscribers_sync_with_list'])) {
            $data['auto_sync_egoi'] = $this->api->getAllSubscribers($data['smart_marketing_subscribers_sync_with_list']);
        }

        $this->loadTpl('extension/egoi/smart_marketing_subscribers', $data);
    }

    /**
     * Executed on syncSubscribers
     * TODO - implement array_chunk
     * @return bool
     */
    public function syncSubscribers()
    {
        if ($this->request->server['REQUEST_METHOD'] == 'POST') {
            $customer_group_id = $this->config->get('smart_marketing_subscribers_customer_group');

            $this->load->model('customer/customer');

            $data_filter = array();
            if(isset($customer_group_id) && $customer_group_id > 0) {
                $data_filter["filter_customer_group_id"] = $customer_group_id;
            }

            $customers = $this->model_customer_customer->getCustomers($data_filter);

            if (!empty($customers)) {
                $i = 0;
                $subscribers = array();
                foreach ($customers as $customer) {
                    // map fields
                    $subscribers[$i] = $this->api->prepareSubscriber($customer);
                    $i++;
                }

                if(count($subscribers) > 0) {
                    $this->api->addSubscriberBulk(
                        $this->config->get('smart_marketing_subscribers_sync_with_list'),
                        $subscribers
                    );
                }

                echo "ok";
                return true;
            }
        }

        return false;
    }

    /**
     * Forms List Page
     */
    public function forms()
    {
        $this->checkUpdate();

        $this->load->model('extension/egoi/egoi');
        $this->load->model('setting/module');

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->link('common/dashboard')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->link('extension/extension', '&type=module')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->link('extension/module/smart_marketing')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_section_forms_title'),
            'href' => $this->link('extension/module/smart_marketing/forms')
        );

        $data['invalid_account'] = $this->invalid_account;

        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_section_title'] = $this->language->get('text_section_forms_title');
        $data['column_id_form'] = $this->language->get('column_id_form');
        $data['column_title'] = $this->language->get('column_title');
        $data['column_type'] = $this->language->get('column_type');
        $data['column_status'] = $this->language->get('column_status');
        $data['column_action'] = $this->language->get('column_action');
        $data['forms_no_results'] = $this->language->get('forms_no_results');
        $data['button_add_form'] = $this->language->get('button_add_form');
        $data['status_active'] = $this->language->get('status_active');
        $data['status_inactive'] = $this->language->get('status_inactive');
        $data['button_edit'] = $this->language->get('button_edit');
        $data['button_delete'] = $this->language->get('button_delete');

        $data['action_edit_form'] = $this->link('extension/module/smart_marketing/form');
        $data['action_remove_form'] = $this->link('extension/module/smart_marketing/removeForm');
        $data['confirm_remove_form'] = $this->language->get('confirm_remove_form');

        $forms = $this->model_setting_module->getModulesByCode('smart_marketing_form');
        $data['forms'] = array_map(function($arr) {
            $arr['setting'] = json_decode($arr['setting']);
            return $arr;
        }, $forms);

        $this->loadTpl('extension/egoi/smart_marketing_list_forms', $data);
    }

    /**
     * Form Configuration Page
     */
    public function form()
    {
        $form_settings = array();

        $this->checkUpdate();

        $this->load->model('extension/egoi/egoi');
        $this->load->model('setting/module');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate("form")) {
            $form_info_post = $this->request->post;

            $form_info_post["name"] = $form_info_post["smart_marketing_form_title"];
            $form_info_post["status"] = $form_info_post["smart_marketing_form_html_status"];
            $form_info_post["module_id"] = $form_info_post["smart_marketing_form_id"];
            $priority = $form_info_post["smart_marketing_form_position_priority"];

            $module_id = $this->request->post['smart_marketing_form_id'];
            if (empty($module_id)) {
                $module_id = $this->model_extension_egoi_egoi->addModule('smart_marketing_form', $form_info_post);
            } else {
                $this->model_setting_module->editModule($this->request->post['smart_marketing_form_id'], $form_info_post);
            }

            // set position for output form
            $this->model_extension_egoi_egoi->setPosition(
                true,
                "smart_marketing_form.".$module_id,
                $form_info_post["smart_marketing_form_layout_position"],
                $priority,
                "home"
            );

            // TODO - change this redirect
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->link('extension/module/smart_marketing/forms', '&type=module'));
        }

        if (isset($this->error['form_title'])) {
            $data['error_form_title'] = $this->error['form_title'];
        } else {
            $data['error_form_title'] = '';
        }

        if (isset($this->error['form_styles_border_size'])) {
            $data['error_form_styles_border_size'] = $this->error['form_styles_border_size'];
        } else {
            $data['error_form_styles_border_size'] = '';
        }

        if (isset($this->error['form_styles_border_color'])) {
            $data['error_form_styles_border_color'] = $this->error['form_styles_border_color'];
        } else {
            $data['error_form_styles_border_color'] = '';
        }

        if (isset($this->error['form_styles_box_width'])) {
            $data['error_form_styles_box_width'] = $this->error['form_styles_box_width'];
        } else {
            $data['error_form_styles_box_width'] = '';
        }

        if (isset($this->error['form_styles_box_height'])) {
            $data['error_form_styles_box_height'] = $this->error['form_styles_box_height'];
        } else {
            $data['error_form_styles_box_height'] = '';
        }

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->link('common/dashboard')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->link('extension/extension', '&type=module')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->link('extension/module/smart_marketing')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_section_forms_title'),
            'href' => $this->link('extension/module/smart_marketing/forms')
        );

        if (!isset($this->request->get['smart_marketing_form_id'])) {
            $data['breadcrumbs'][] = array(
                'text' => $this->language->get('text_section_new_form_title'),
                'href' => $this->link('extension/module/smart_marketing/form')
            );
        } else {
            $data['breadcrumbs'][] = array(
                'text' => $this->language->get('text_section_edit_form_title') . " (ID: " . $this->request->get['smart_marketing_form_id'] . ")",
                'href' => $this->link(
                    'extension/module/smart_marketing/form',
                    '&smart_marketing_form_id='.$this->request->get['smart_marketing_form_id']
                )
            );
        }

        if (isset($this->request->get['smart_marketing_form_id'])){
            $form_settings = $this->model_setting_module->getModule($this->request->get['smart_marketing_form_id']);
        }

        $data['action'] = $this->link('extension/module/smart_marketing/form');
        $data['cancel'] = $this->link('extension/module/smart_marketing/forms');
        $data['heading_title'] = $this->language->get('heading_title');

        if (!isset($this->request->get['smart_marketing_form_id'])) {
            $data['text_section_title'] = $this->language->get('text_section_new_form_title');
        }else{
            $data['text_section_title'] = $this->language->get('text_section_edit_form_title') . " (ID: " . $this->request->get['smart_marketing_form_id'] . ")";
        }

        $data['entry_form_type'] = $this->language->get('entry_form_type');
        $data['option_form_html'] = $this->language->get('option_form_html');
        $data['option_form_popup'] = $this->language->get('option_form_popup');
        $data['option_form_iframe'] = $this->language->get('option_form_iframe');
        $data['option_no'] = $this->language->get('option_no');
        $data['option_yes'] = $this->language->get('option_yes');
        $data['entry_form_title'] = $this->language->get('entry_form_title');
        $data['entry_form_html_status'] = $this->language->get('entry_form_html_status');
        $data['entry_form_layout_position'] = $this->language->get('entry_form_layout_position');
        $data['tab_content'] = $this->language->get('tab_content');
        $data['tab_style'] = $this->language->get('tab_style');
        $data['entry_form_html_show_title'] = $this->language->get('entry_form_html_show_title');
        $data['entry_form_iframe_subscribe_list'] = $this->language->get('entry_form_iframe_subscribe_list');
        $data['entry_form_iframe_form'] = $this->language->get('entry_form_iframe_form');
        $data['entry_form_styles_border_size'] = $this->language->get('entry_form_styles_border_size');
        $data['entry_form_styles_border_color'] = $this->language->get('entry_form_styles_border_color');
        $data['entry_form_styles_box_width'] = $this->language->get('entry_form_styles_box_width');
        $data['entry_form_styles_box_height'] = $this->language->get('entry_form_styles_box_height');
        $data['entry_form_html_show_only_one_time'] = $this->language->get('entry_form_html_show_only_one_time');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        if (isset($this->request->post['smart_marketing_form_type'])) {
            $data['smart_marketing_form_type'] = $this->request->post['smart_marketing_form_type'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_type'] = $form_settings['smart_marketing_form_type'];
        } else {
            $data['smart_marketing_form_type'] = $this->config->get('smart_marketing_form_type');
        }

        if (isset($this->request->post['smart_marketing_form_html_status'])) {
            $data['smart_marketing_form_html_status'] = $this->request->post['smart_marketing_form_html_status'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_html_status'] = $form_settings['smart_marketing_form_html_status'];
        } else {
            $data['smart_marketing_form_html_status'] = $this->config->get('smart_marketing_form_html_status');
        }

        if (isset($this->request->post['smart_marketing_form_title'])) {
            $data['smart_marketing_form_title'] = $this->request->post['smart_marketing_form_title'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_title'] = $form_settings['smart_marketing_form_title'];
        } else {
            $data['smart_marketing_form_title'] = $this->config->get('smart_marketing_form_title');
        }

        if (isset($this->request->post['smart_marketing_form_html_show_title'])) {
            $data['smart_marketing_form_html_show_title'] = $this->request->post['smart_marketing_form_html_show_title'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_html_show_title'] = $form_settings['smart_marketing_form_html_show_title'];
        } else {
            $data['smart_marketing_form_html_show_title'] = $this->config->get('smart_marketing_form_html_show_title');
        }

        if (isset($this->request->post['smart_marketing_form_iframe_subscribe_list'])) {
            $data['smart_marketing_form_iframe_subscribe_list'] = $this->request->post['smart_marketing_form_iframe_subscribe_list'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_iframe_subscribe_list'] = $form_settings['smart_marketing_form_iframe_subscribe_list'];
        } else {
            $data['smart_marketing_form_iframe_subscribe_list'] = $this->config->get('smart_marketing_form_iframe_subscribe_list');
        }

        if (isset($this->request->post['smart_marketing_form_iframe_form'])) {
            $data['smart_marketing_form_iframe_form'] = $this->request->post['smart_marketing_form_iframe_form'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_iframe_form'] = isset($form_settings['smart_marketing_form_iframe_form']) ? $form_settings['smart_marketing_form_iframe_form'] : null;
        } else {
            $data['smart_marketing_form_iframe_form'] = $this->config->get('smart_marketing_form_iframe_form');
        }

        if (isset($this->request->post['smart_marketing_form_styles_border_size'])) {
            $data['smart_marketing_form_styles_border_size'] = $this->request->post['smart_marketing_form_styles_border_size'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_styles_border_size'] = $form_settings['smart_marketing_form_styles_border_size'];
        } else {
            $data['smart_marketing_form_styles_border_size'] = $this->config->get('smart_marketing_form_styles_border_size');
        }

        if (isset($this->request->post['smart_marketing_form_styles_border_color'])) {
            $data['smart_marketing_form_styles_border_color'] = $this->request->post['smart_marketing_form_styles_border_color'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_styles_border_color'] = $form_settings['smart_marketing_form_styles_border_color'];
        } else {
            $data['smart_marketing_form_styles_border_color'] = $this->config->get('smart_marketing_form_styles_border_color');
        }

        if (isset($this->request->post['smart_marketing_form_position_priority'])) {
            $data['smart_marketing_form_position_priority'] = $this->request->post['smart_marketing_form_position_priority'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_position_priority'] = $form_settings['smart_marketing_form_position_priority'];
        } else {
            $data['smart_marketing_form_position_priority'] = $this->config->get('smart_marketing_form_position_priority');
        }

        if (isset($this->request->post['smart_marketing_form_styles_box_width'])) {
            $data['smart_marketing_form_styles_box_width'] = $this->request->post['smart_marketing_form_styles_box_width'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_styles_box_width'] = $form_settings['smart_marketing_form_styles_box_width'];
        } else {
            $data['smart_marketing_form_styles_box_width'] = $this->config->get('smart_marketing_form_styles_box_width');
        }

        if (isset($this->request->post['smart_marketing_form_id'])) {
            $data['smart_marketing_form_html_show_only_one_time'] = $this->request->post['smart_marketing_form_html_show_only_one_time'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_html_show_only_one_time'] = $form_settings['smart_marketing_form_html_show_only_one_time'];
        } else {
            $data['smart_marketing_form_html_show_only_one_time'] = $this->config->get('smart_marketing_form_html_show_only_one_time');
        }

        if (isset($this->request->post['smart_marketing_form_styles_box_height'])) {
            $data['smart_marketing_form_styles_box_height'] = $this->request->post['smart_marketing_form_styles_box_height'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_styles_box_height'] = $form_settings['smart_marketing_form_styles_box_height'];
        } else {
            $data['smart_marketing_form_styles_box_height'] = $this->config->get('smart_marketing_form_styles_box_height');
        }

        if (isset($this->request->post['smart_marketing_form_html_html'])) {
            $data['smart_marketing_form_html_html'] = $this->request->post['smart_marketing_form_html_html'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_html_html'] = $form_settings['smart_marketing_form_html_html'];
        } else {
            $data['smart_marketing_form_html_html'] = $this->config->get('smart_marketing_form_html_html');
        }

        if (isset($this->request->post['smart_marketing_form_id'])) {
            $data['smart_marketing_form_id'] = $this->request->post['smart_marketing_form_id'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_id'] = $this->request->get['smart_marketing_form_id'];
        } else {
            $data['smart_marketing_form_id'] = $this->config->get('smart_marketing_form_id');
        }

        if (isset($this->request->post['smart_marketing_form_id'])) {
            $data['smart_marketing_form_layout_position'] = $this->request->post['smart_marketing_form_layout_position'];
        } else if (isset($this->request->get['smart_marketing_form_id'])) {
            $data['smart_marketing_form_layout_position'] = $form_settings['smart_marketing_form_layout_position'];
        } else {
            $data['smart_marketing_form_layout_position'] = $this->config->get('smart_marketing_form_layout_position');
        }

        if (isset($this->error['form_title'])) {
            $data['error_form_title'] = $this->error['form_title'];
        } else {
            $data['error_form_title'] = '';
        }

        if (isset($this->error['form_styles_border_size'])) {
            $data['error_form_styles_border_size'] = $this->error['form_styles_border_size'];
        } else {
            $data['error_form_styles_border_size'] = '';
        }

        if (isset($this->error['form_styles_border_color'])) {
            $data['error_form_styles_border_color'] = $this->error['form_styles_border_color'];
        } else {
            $data['error_form_styles_border_color'] = '';
        }

        if (isset($this->error['form_styles_box_width'])) {
            $data['error_form_styles_box_width'] = $this->error['form_styles_box_width'];
        } else {
            $data['error_form_styles_box_width'] = '';
        }

        if (isset($this->error['form_styles_box_height'])) {
            $data['error_form_styles_box_height'] = $this->error['form_styles_box_height'];
        } else {
            $data['error_form_styles_box_height'] = '';
        }

        // TODO - change this to ajax in the future
        $lists = $this->api->getLists();
        $data['lists'] = $lists;
        $data['url_forms'] = $this->link('extension/module/smart_marketing/getForms');

        // check if account is still valid
        $data['invalid_account'] = $this->invalid_account;

        $this->loadTpl('extension/egoi/smart_marketing_form', $data);
    }

    /**
     * Remove Form via Ajax
     *
     * @return bool
     */
    public function removeForm()
    {
        if ($this->request->server['REQUEST_METHOD'] == 'POST') {
            if ($form_id = $this->request->post['smart_marketing_form_id']) {

                // delete form module ID
                $this->load->model('extension/egoi/egoi');
                $this->load->model('setting/module');
                $this->model_setting_module->deleteModule($form_id);
                echo json_encode(['Form removed with success']);
                return true;
            }
        }

        return false;
    }

    /**
     * Get Forms via Ajax
     *
     * @return bool
     */
    public function getForms()
    {
        if ($this->request->server['REQUEST_METHOD'] == 'POST') {
            echo json_encode($this->api->getForms($this->request->post['list'], true));
            return true;
        }

        return false;
    }

    /**
     * Validates the data when Save Button is pressed
     *
     * @param string $post_section
     * @return bool
     */
    protected function validate($post_section = "index")
    {
        if (!$this->user->hasPermission('modify', 'extension/module/smart_marketing')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        switch ($post_section) {
            case "lists":
                if (utf8_strlen($this->request->post['smart_marketing_list_name']) == 0) {
                    $this->error['error_list_name'] = $this->language->get('error_list_name');
                }
                break;

            case "form":
                if (utf8_strlen($this->request->post['smart_marketing_form_title'])<4) {
                    $this->error['form_title'] = $this->language->get('error_form_title');
                }
                break;

            case "index":
                if (utf8_strlen($this->request->post['smart_marketing_api']) == 0) {
                    $this->error['field'] = $this->language->get('error_api_empty');
                }else{

                    // check if login is valid
                    $this->api->apiKey = $this->request->post['smart_marketing_api'];
                    $response = $this->api->checkLogin();

                    (isset($response["RESULT"]) && $response["RESULT"] == "OK" ?:
                        $this->error['api'] = $this->language->get('error_api_invalid'));
                }
                break;
        }

        return !$this->error;
    }

	/**
	 * Saves sms notifications data
	 *
	 * @return bool
	 */
	private function saveSmsNotificationData() {
		$this->load->model('setting/setting');

		$has_egoi_shipping_courier_uri = $this->db->query("SHOW COLUMNS FROM `" . DB_PREFIX . "shipping_courier` WHERE Field='shipping_courier_tracking_uri'")->num_rows > 0;
		if ($has_egoi_shipping_courier_uri) {
			foreach ($this->request->post as $key => $value) {
				if ("courier_" == substr($key, 0, 8)) {

					$courier = explode('_', $key);
					$this->db->query("UPDATE `" . DB_PREFIX . "shipping_courier` SET shipping_courier_tracking_uri = '" . $this->db->escape($value) . "' WHERE shipping_courier_id = '" . (int)$this->db->escape($courier[1]) . "'");

					unset($this->request->post[$key]);
				}
			}
		}


		if(!empty($this->config->get('smart_marketing_sms_notifications_install_date'))) {
			$this->request->post['smart_marketing_sms_notifications_install_date'] = $this->config->get('smart_marketing_sms_notifications_install_date');
		} else {
			$this->request->post['smart_marketing_sms_notifications_install_date'] = date('Y-m-d H:i:s');
		}

		if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
			$this->model_setting_setting->editSetting('smart_marketing_sms_notifications', $this->request->post);
			echo json_encode(array('success' => true));
			return true;
		}
		echo json_encode(array('error' => true));
		return false;
	}

    /**
     * Get all E-goi Lists with custom data
     *
     * @return mixed
     */
    private function getLists()
    {
        $data['column_id_lista'] = $this->language->get('column_id_lista');
        $data['column_titulo'] = $this->language->get('column_titulo');
        $data['column_titulo_interno'] = $this->language->get('column_titulo_interno');
        $data['column_subscritores_ativos'] = $this->language->get('column_subscritores_ativos');
        $data['column_total_subscritores'] = $this->language->get('column_total_subscritores');
        $data['column_idioma'] = $this->language->get('column_idioma');
        $data['column_action'] = $this->language->get('column_action');

        $data['button_edit'] = $this->language->get('button_edit');

        $data['text_section_title'] = $this->language->get('text_section_lists_title');
        $data['text_no_results'] = $this->language->get('text_no_results');

        $listas = $this->api->getLists();
        $data['lists'] = $listas;

        return $data;
    }

    /**
     * Get custom Form List Creation vars
     *
     * @return mixed
     */
    private function getFormCustomVars()
    {
        $data['text_section_add_list_title'] = $this->language->get('text_section_add_list_title');
        $data['entry_lang'] = $this->language->get('entry_lang');
        $data['entry_list_name'] = $this->language->get('entry_list_name');

        if (isset($this->request->post['smart_marketing_lang'])) {
            $data['smart_marketing_lang'] = $this->request->post['smart_marketing_lang'];
        } else {
            $data['smart_marketing_lang'] = $this->config->get('smart_marketing_lang');
        }

        if (isset($this->request->post['smart_marketing_list_name'])) {
            $data['smart_marketing_list_name'] = $this->request->post['smart_marketing_list_name'];
        } else {
            $data['smart_marketing_list_name'] = $this->config->get('smart_marketing_list_name');
        }

        $data['error_list_name'] = isset($this->error['error_list_name']) ? $this->error['error_list_name'] : '';

        $data['save_list'] = $this->language->get('save_list');
        $data['action'] = $this->link('extension/module/smart_marketing/lists');

        return $data;
    }

    /**
     * @param $tpl
     * @param array $data
     */
    private function loadTpl($tpl, $data = array())
    {
        // extend templates
        $data_common_tpl['header'] = $this->load->controller('common/header');
        $data_common_tpl['column_left'] = $this->load->controller('common/column_left');
        $data_common_tpl['footer'] = $this->load->controller('common/footer');

        $data = array_merge($data, $data_common_tpl);

        // set tpl output
        $this->response->setOutput($this->load->view($tpl, $data));
    }

    /**
     * @param $route
     * @param string $custom_args
     * @param bool $secure
     * @return mixed
     */
    private function link($route, $custom_args = '', $secure = true)
    {
        return $this->url->link(
            $route,
            'user_token=' . $this->session->data['user_token'] . $custom_args,
            $secure
        );
    }
}
