<?php

include_once DIR_SYSTEM . "/library/egoi/egoi_api.php";

/**
 * Class ControllerExtensionModuleSmartMarketingSubscribers
 * @author E-goi
 */
class ControllerExtensionModuleSmartMarketingSubscribers extends Controller
{

    /**
     * @return string
     */
    public function index()
    {
        return (!empty($this->request->get["route"]) && $this->request->get["route"] == "checkout/success") ?:
            $this->getTrackAndEngage('egoi/track_and_engage');
    }

    /**
     * @param $order_id
     * @return string
     */
    public function checkout($order_id)
    {
        return $this->getTrackAndEngage('egoi/track_and_engage', $order_id);
    }

    /**
     * @param $template
     * @param string $order_id
     * @return string
     */
    private function getTrackAndEngage($template, $order_id = "")
    {
        if ($api_key = $this->config->get('smart_marketing_api')) {
            if ($this->config->get('smart_marketing_subscribers_track_and_engage')) {

                $api = new EgoiAPI($api_key);
                $client_data = $api->getClientData();

                if (!empty($client_data)) {

                    // set client data
                    $data["setClientId"] = $client_data["CLIENTE_ID"];
                    $data["setSubscriber"] = $this->customer->isLogged() ? (!empty($this->customer->getEmail()) ? $this->customer->getEmail() : $this->customer->getTelephone()) : "";
                    $data["setListId"] = $this->config->get('smart_marketing_subscribers_sync_with_list');

                    $data["hasOrder"] = false;
                    if (!empty($order_id)) {
                        $data["hasOrder"] = true;
                        $data = $this->getOrderDetails($order_id, $data);
                    }

                    return $this->load->view($template, $data);
                }
            }
        }

        return "";
    }

    /**
     * @param $order_id
     * @param $data
     * @return mixed
     */
    private function getOrderDetails($order_id, &$data)
    {
        $this->load->model('extension/module/egoi');

        $dbproducts = $this->model_extension_module_egoi->getProductsByOrderId($order_id);

        for($i =0;$i<count($dbproducts);$i++){
            if(isset($dbproducts[$i]['product_price'])){
                $dbproducts[$i]['product_price'] = number_format($dbproducts[$i]['product_price'], 2, ".", "");
            }
            
            $dbproducts[$i]['product_cat'] = "-";
        }

        $total = $this->model_extension_module_egoi->getOrderFinalValuesByCode($order_id, 'total')["value"];
        $sub_total = $this->model_extension_module_egoi->getOrderFinalValuesByCode($order_id, 'sub_total')["value"];
        $tax = $this->model_extension_module_egoi->getOrderFinalValuesByCode($order_id, 'tax')["value"];
        $shipping = $this->model_extension_module_egoi->getOrderFinalValuesByCode($order_id, 'shipping')["value"];
        $discount = $this->model_extension_module_egoi->getOrderDiscountValueById($order_id)["value"];

        $data["orderId"] = $order_id;
        $data["total"] = number_format($total, 2, ".", "");
        $data["sub_total"] = number_format($sub_total, 2, ".", "");
        $data["tax"] = number_format($tax, 2, ".", "");
        $data["shipping"] = number_format($shipping, 2, ".", "");
        $data["discount"] = number_format($discount, 2, ".", "");
        $data["products"] = $dbproducts;

        return $data;
    }
}